#include "cssysdef.h"
#include "xCollider.h"
#include "xCoDS.h"
#include <stdlib.h>
#include <iostream.h>



xCollider::xCollider(xObject* pObj) 
{
  pxObj = pObj;
  iMeshWrapper* piMesh = pxObj->getMesh();
  PCO = NULL;
  piMesh->GetWorldBoundingBox(AABB);
  bMeshMoved = true;
}

void xCollider::buildPCO(int npco) {
  if(PCO)
    delete [] PCO;
  PCO = new short[npco];
  for(int i=0;i<npco;i++)
    // no collisions on either axis
    PCO[i]=0;
}


xCollider::~xCollider() {
   if(PCO)
    delete [] PCO; 
}

void xCollider::printPCO(int npco) {
  for(int i=0;i<npco;i++) {
    if(PCO[i]>0) {
      // collides on some axis
      cout<<"colides with "<<i<<" on ";
      if(AXIS_OX&PCO[i]) cout<<" Ox ";
      if(AXIS_OY&PCO[i]) cout<<" Oy ";
      if(AXIS_OZ&PCO[i]) cout<<" Oz ";
      cout<<"\n";
    }
  }
}

bool xCollider::isPotentiallyColliding(int id) { 
  if(PCO) 
    return (PCO[id] == (AXIS_OX | AXIS_OY | AXIS_OZ));
  else
    return false;
}
 

// this is called whenever the object moved
// or changed its shape
// if it changed its shape this is not enough.
// MUST recompute OBB tree for RAPID too.
void xCollider::setMovedFlag(bool bf) {
  bMeshMoved = bf;
  // if the object changed is AABB gotta update the coordinates
  if(Moved()) {

    iMeshWrapper* piMesh = pxObj->getMesh();
    // get the new bounding box
    piMesh->GetWorldBoundingBox(AABB);

    xAABB[0]->Value = OxLeft();
    xAABB[1]->Value = OxRight();
    xAABB[2]->Value = OyLeft();
    xAABB[3]->Value = OyRight();
    xAABB[4]->Value = OzLeft();
    xAABB[5]->Value = OzRight();
  }
}
